require 'thor'

module Findbugs2Checkstyle
  class CLI < Thor
    include ::Findbugs2Checkstyle::Convert
    desc 'convert', 'Exec Convert'
    option :data
    option :file
    def convert
      data = fetch_data(options)
      xml = parse(data)
      checkstyle = trans(xml)
      checkstyle.write(STDOUT, 2)
    end

    no_commands do
      def fetch_data(options)
        data = \
          if options[:data]
            options[:data]
          elsif options[:file]
            File.read(options[:file])
          elsif !$stdin.tty?
            ARGV.clear
            ARGF.read
          end

        fail NoInputError if !data || data.empty?

        data
      end
    end
  end
end
